/*
 * extract-checked.js  -- `FbNX𒊏o
 *
 */

var menu_obj = new Array();

init();

function init()
{
    var idx, menu;

    // add to MainWnd.ThreadPopupMenu
    idx = JaneScript.MenuIndex("MainWnd.ThreadPopupMenu", "ViewPopupCheckRes");

    menu = JaneScript.InsertMenu("MainWnd.ThreadPopupMenu",
                                 "",
                                 idx + 1);
    menu.Caption = "`FbNX𒊏o";
    menu.OnClick = function(menu_obj, target_info) {
        extract_checked(target_info.PopupObject);
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        menu_obj.Enabled = (target_info.PopupObject.ViewType == "ThreadView");
    };
    menu_obj.push(menu);

    // add to MainWnd.MainMenu
    idx = JaneScript.MenuIndex("MainWnd.MainMenu", "MenuThreCheckRes");

    menu = JaneScript.InsertMenu("MainWnd.MainMenu",
                                 "MenuThre",
                                 idx + 1);
    menu.Caption = "`FbNX𒊏o";
    menu.OnClick = function(menu_obj, target_info) {
        extract_checked(JaneScript.ActiveView());
    };
    menu.OnBeforeShow = function(menu_obj, target_info) {
        menu_obj.Enabled = (JaneScript.ActiveView() != null &&
                            JaneScript.ActiveView().ViewType == "ThreadView");
    };
    menu_obj.push(menu);

    // clean-up
    menu = null;
}

function extract_checked(view_item)
{
    var i;
    var checked_res = new Array();

    var thread = view_item.Thread;

    for(i = 1; i <= thread.Lines; i++) {
        if((thread.GetAbone(i) & 0x4) != 0) {
            checked_res.push(i);
        }
    }

    if(checked_res.length < 1) {
        return;
    }

    var new_view = JaneScript.viewList.NewView(false, false);
    try {
        new_view.TabText = "`FbNXo";
        new_view.ExtraTitle = "y`FbNXoz" + thread.Title;

        var datout = new_view.QueryDatOut();
        new_view.WriteSkin("");
        datout.WriteHTML("y`FbNXoz<br>");
        datout.WriteHTML("ΏۃXF <a href=\"" + thread.URL + "\">" +
                         thread.Title + "</a><br>");
        datout.WriteHTML("<br><br>");

        for(i = 0; i < checked_res.length; i++) {
            datout.WriteThread(thread, checked_res[i], checked_res[i], 0);
        }
    }
    catch(e) {
        if((e.number & 0xffff) != 0x8001) {
            // other than E_JaneScriptObjectDisconnected
            throw e;
        }
    }
    finally {
        if(new_view.Connected) {
            new_view.EndDatOut();
        }
    }
}
